#!/usr/local/bin/perl -w

use Thread;
use Thread::Queue;
use Thread::Semaphore;

$| = 1;                     # Ausgabe entpuffern
$max_parallel_jobs = 3;     # Parallel abzuarbei-
                            # tende Jobs
$total_jobs        = 5;
                            # Neue Ergebnis-Queue
$results = Thread::Queue->new();

$sem = Thread::Semaphore->new($max_parallel_jobs);

foreach $job (1..$total_jobs) {   # Jobs erzeugen
    my $sleep_time = int(rand(10)+1);
                            # Task in TODO stecken
    push(@todo, [\&task, $job, $sleep_time]); 
}                                       

##################################################
# Weitermachen, solange noch Jobs in TODO stehen

while($#todo >= 0) {
  my($funcref, $job, $sleep_time) = @{shift(@todo)};
 
  $sem->down();         # Nur N Tasks gleichzeitig

                        # Neuen Thread erzeugen
  my $thread = Thread->new($funcref, $sleep_time,
                           $results, $sem);
  $thread->detach();    # Abkoppeln
  
  # Formatierter Zeitstempel fr Ausgabe
  $time = sprintf "%02d:%02d:%02d", 
                  (localtime())[2,1,0];

  # Anzahl laufender Threads ermitteln - Main
  # zaehlt mit, also $#threads, nicht $#threads+1
  @threads = Thread->list();
  print "$time> task($job) started (RUNNING[",
        $#threads, "] TODO[", $#todo+1, "])\n";
}

# Ergebnis ausgeben:
for $job (1..$total_jobs) {
                       # Ergebnis aus Queue holen
                       # (notfalls warten)
    $result = $results->dequeue();
    my ($thread_id, $sleep_secs ) = @$result;
                       # ID und Sekunden ausgeben
    print "Thread $thread_id slept for " .
          "$sleep_secs seconds\n";
}

##################################################
sub task {
##################################################
    my ($sleep_secs,     # Parameter
        $result,         # Ergebnis-Queue
        $sem             # Semaphor
       ) = @_;
    
    # Kostspiele Aufgabe ausfhren
    sleep($sleep_secs);

    # Ergebnis ablegen
    $result->enqueue([Thread->self->tid(),
                     $sleep_secs]);

    # Semaphor um Eins erhhen, eine Task mehr zu- 
    # lassen, da der Thread gleich beendet wird.
    $sem->up();

    # Implizites Thread-Ende (return)
}
